uint32_t *rp;
int spa[400],spa_count,spb[400];
int maxpwm,v;
float a0,a1,a2,b1,b2,z1,z2;

void setup() 
{
  // 400 swpm cycles per 50Hz cycle.
  // 200 as a 1/2 wave sine, from 0 to pi
  // 200 as the inverse i.e. 1-sine
  int i;
  float th,a;
  maxpwm = 4200;
  for (i=0; i < 200; i++)
    {
      th = 3.14159 * (float)i/200.0;
      a = (float)(maxpwm) * 0.99*sin(th) ;
      spa[i] = (int)a;
      spb[i+200] = spa[i];
      spb[i] = maxpwm - spa[i];  
    }
  spa_count=0;  
  pwmc_setup();
  REG_PWM_CDTY1 = 26250;
  ADC->ADC_MR |= 0x80;  //set free running mode on ADC
  ADC->ADC_CHER = 0xc0; //enable ADC on pin A0
  Serial.begin(115200);
  z1=z2=0.0;  
}

void loop() 
{
// work out error, increase or decrease spb[] accordingly
// read analog input, scale and get delta from setpoint, use a bit of PID to drive correction factor
// impliment the soft start, disable/enable output (only during 50Hz zero crossing)
// likely that this code will get interrupted by one or both of the PWM and so we have a situation where
// this code is writing to data that the interrupt routine will be reading.
//
REG_PIOD_ODSR = 2; REG_PIOD_ODSR = 0; // toggle pin 25
//REG_PIOD_ODSR = 1; REG_PIOD_ODSR = 0; // toggle pin 26
//
float r,s,t,f;
int j,k;
unsigned long u;
// sample A0, using direct register access
//while((ADC->ADC_ISR & 0x80)==0);
j = ADC->ADC_CDR[7];
//k = ADC->ADC_CDR[6]; for A1 analog input

// filter a bit, in a shitty way
//t = 0.01*(float)j + 0.99*t;
//s = t/35.6;   // 0.0 <= s <= 1.0

s = (float)j/4086.0;

// biquad 2 pole butterworth LP filter, 2000Hz sample rate, 1.7Hz -3db cutoff
a0= 9.7769425E-6; a1= 1.9553885E-5; a2= 9.7769425E-6; b1= -1.9911366; b2= 0.9911756;
f = s*a0 + z1;
z1 = s*a1 + z2 - b1*f;
z2 = s*a2 - b2*f;
s = f;

for(j=0; j < 200; j++)
  {
  r = (float)spa[j] * s; 
  k = (int)r; 
  spb[j+200] = k;
  spb[j] = maxpwm - k;
  }
}

void pwmc_setup()
{
  //Configure PWM channels 0,1 (PWML0,PWMH0,PWML1,PWMH1), (port C.2,C.3,C.4,C.5), (pins P34,P35,P36,P37)
  REG_PIOC_PDR = 0x3FC;  //B1111111100, PIO Disable Register
  REG_PIOC_ABSR = REG_PIOC_ABSR | 0x3FCu; //B1111111100, Peripheral AB Select Register

  pmc_enable_periph_clk(ID_PWM);
  REG_PWM_ENA = REG_PWM_SR | 0x000003; //PWM Enable Register | PWM Status Register (activate channels 0,1), was B11111   ie all 5 low
 
  REG_PWM_CMR0 = 0x10000; //Channe0 Mode Register: Dead Time Enable DTE=1, clock divider = 0, use Mclk
  REG_PWM_CMR1 = 0x10005; //Channe1 Mode Register: Dead Time Enable DTE=1, clock divider = 5, use Mclk/512 
  REG_PWM_DT0 = 0x2a002a; //Channe0 Dead Time Register 
  REG_PWM_DT1 = 0x020002; //Channe1 Dead Time Register 
  REG_PWM_CPRD0 = 4200; //Channe0 Period Register  20 kHz
  REG_PWM_CPRD1 = 52500; //Channe1 Period Register 50 Hz

  NVIC_DisableIRQ(PWM_IRQn); // set up interrupt
  NVIC_ClearPendingIRQ(PWM_IRQn);
  NVIC_SetPriority(PWM_IRQn, 0);
  NVIC_EnableIRQ((IRQn_Type)36); //NVIC_EnableIRQ(PWM_IRQn);
  PWM_INTERFACE->PWM_IER1 = 0x0003; //enable interrupt on channel 0
  PWM_INTERFACE->PWM_IDR1 = 0x00FF00fc; //enable interrupt on channel 0
 
 // enable 16 pins in port D
  REG_PIOD_PER = 0x00ff;
  REG_PIOD_OER = 0x00ff;
  REG_PIOD_OWER = 0xFFFF;  
}



void PWM_Handler(void) // PWM interrupt handler
{
   volatile long ir1;
   ir1 = PWM_INTERFACE->PWM_ISR1; // clear interrupt flag
   if ((ir1 & 2) == 2)
    {
    // runs after each cycle of 50Hz  
    spa_count=0;
    }  
   if ((ir1 & 1) == 1)
    {
    // runs after each pwm cycle, 20 kHz 
    REG_PWM_CDTY0 = spb[spa_count];
    spa_count++;
    }  
}






